<?php

/* $Id: auth_xoops.inc,v 1.1 2003/10/15 05:36:53 mikhail Exp $
 *
 * This is a slight variant of auth_ip. 
 * Authentication scheme try to use DNS name to determine
 * admin privileges instaed of ip. Anyone who can access
 *  the server can make bookings etc.
 *
 * To use this authentication scheme set the following
 * things in config.inc:
 *
 * $auth["type"]  = "xoops";
 *
 * Then, you may configure admin users:
 *
 * $auth["admin"][] = "DNSname1";
 * $auth["admin"][] = "DNSname2";
 */

# No need to perform authentication - if no DNSname is returned, ip address
# is used
function authGet($realm) { }

# Always validates
function authValidateUser($user, $pass) { return 1; }

/* authGetUserLevel($user)
 * 
 * Determines the users access level
 * 
 * $user - The user name
 *
 * Returns:
 *   The users access level
 */
function authGetUserLevel($user, $lev1_admin)
{
	global $xoopsUser, $xoopsModule, $xoopsDB;

	// User not logged in, user level '0'
	if(!$xoopsUser)
		return 0;
        
	$xoopsModule =

XoopsModule::getByDirname("mrbs");
	if ( $xoopsUser->isAdmin($xoopsModule->mid()) ) { 
        return 2;
	}
	
	// Everybody else is access level '1'
	return 1;
}

function getUserName()
{
	global $xoopsUser;
    if($xoopsUser) {
        return $xoopsUser->uid();
    } else {
        return 0;    
    }
}

# NOT used :
function getUserPassword()
{
	return "dummy";
}

?>
