<?php
// ------------------------------------------------------------------------- //
//                      MyAddress - XOOPS addressbook                        //
//                        <http://forum.kuri3.net/>                          //
// ------------------------------------------------------------------------- //

//-------------------------------------------------------------------//
//               Display search results in list style                //
//-------------------------------------------------------------------//

function search_results( $mode, $cid, $skey, $c_id=0, $needSearch="y" ) {
	global $myts, $xoopsDB, $cattree, $xoopsTpl;
	global $table_addressbook, $table_company;
	global $myaddress_numperpage, $myaddress_catorder;
	global $isadmin, $myaddress_mid, $my_uid, $my_groups, $mod_url;
	global $op, $from;

	$children = $cattree->getAllChildId( $cid );
	$children = push_gperm_array( $children, "myadrs_category" );

	$keyarray = get_keyarray();
	$skey_last = count($keyarray) - 2;
	$skey_all = count($keyarray) - 1;

	$requestStart = TRUE;
	$requestEnd = TRUE;
	if ($skey == 0) {
		$requestStart = FALSE;
	} elseif ( $skey == $skey_last ) {
		$requestEnd = FALSE;
	} elseif ( $skey == $skey_all ) {
		$requestStart = FALSE;
		$requestEnd = FALSE;
	}

	switch ( $mode ) {
		// name-based mode
		case 1:
			$count = "SELECT count(l.aid) FROM $table_addressbook l";
			$select = "SELECT l.aid, l.cid, l.c_id, l.fullname, l.myphone, l.mycellphone1, l.myemail1, l.myemail2, l.cphone, l.uid, c.cid, c.cname, c.cdivision, c.cphone FROM $table_addressbook l LEFT JOIN $table_company c ON l.c_id=c.c_id ";
			$where = " WHERE";
			if ( $requestStart ) {
				$where .= " substring(l.last_name_jh, 1, 2) >= '$keyarray[$skey]' AND";
			}
			if ( $requestEnd ) {
				$skey2 = $skey + 1;
				$where .= " substring(l.last_name_jh, 1, 2) < '$keyarray[$skey2]' AND";
			}
			$where .=" ( l.uid = $my_uid || l.disclosed = 1 )";
			$where .= " AND l.cid IN (";
			foreach( $children as $child ) {
				$where .= " $child,";
			}
			$where .= " $cid )";
			$order =" ORDER BY l.fullname_jh";
			break;

		// company-based mode
		case 2:
			$count = "SELECT count(c_id) FROM $table_company";
			$select = "SELECT c_id, cid, cdivision, cname, cphone, cfax, cweb  FROM $table_company";
			$where = " WHERE";
			if ($op == "list" && $needSearch ="n") {
				$where .= " c_id=$c_id";
			} else {
				if ( $requestStart ) {
					$where .= " substring(cname_jh, 1, 2) >= '$keyarray[$skey]' AND";
				}
				if ( $requestEnd ) {
					$skey2 = $skey + 1;
					$where .= " substring(cname_jh, 1, 2) < '$keyarray[$skey2]' AND";
				}
//				$where .=" uid = $my_uid";
				$where .= " cid IN (";
				foreach( $children as $child ) {
					$where .= " $child,";
				}
				$where .= " $cid )";
			}
			$order =" ORDER BY cname_jh";
			break;
		default:
			break;
	}

	// get the total numbers of affected addresses
	$sql = $count . $where;

	$res_total = $xoopsDB->query( $sql );
	list( $total ) = $xoopsDB->fetchRow( $res_total );
	$total = intval($total);

	$addresses = array(
		'lang_search' => _MD_MYADDRESS_SEARCH,
		'lang_results' => _MD_MYADDRESS_RESULTS,
		'total_found' => $total
	);

	if ( $total == 0 ) {
		$addresses['lang_nonefound'] = _MD_MYADDRESS_NOFOUND;

	} else  {
		// make a page navigation clause
		if ( $total > $myaddress_numperpage ) {
			include XOOPS_ROOT_PATH."/class/pagenav.php";
			$nav = new XoopsPageNav( $total, $myaddress_numperpage, $from, 'from', "mode=$mode&cid=$cid&op=search&skey=$skey" );	
			$nav_clause = $nav->renderNav( 10 );
		} else {
			$nav_clause = "";
		}

		// display the information of the present page
		$to = $from + $myaddress_numperpage;
		if( $to > $total ) $to = $total ;
		$navinfo = sprintf( _MD_MYADDRESS_NAVINFO, $from + 1, $to, $total );
		$addresses['pagenav'] = $navinfo ."&nbsp;". $nav_clause ."&nbsp";

		switch ( $mode ) {
			// name-based mode
			case 1:
				// get addressbook
				$sql = $select . $where . $order;
				$result = $xoopsDB->query( $sql, $myaddress_numperpage, $from );
				// assign header
				$addresses['lang_fullname'] = _MD_MYADDRESS_FULLNAME;
				$addresses['lang_myphone'] = _MD_MYADDRESS_PHONE;
				$addresses['lang_mycellphone1'] = _MD_MYADDRESS_CELLPHONE;
				$addresses['lang_myemail1'] = _MD_MYADDRESS_EMAIL1;
				$addresses['lang_myemail2'] = _MD_MYADDRESS_EMAIL2;
				$addresses['lang_cname'] = _MD_MYADDRESS_CNAME;
				$addresses['lang_cphone'] = _MD_MYADDRESS_CPHONE;

				// assign addressbook data to template
				while( list($aid, $acid, $c_id, $fullname, $myphone, $mycellphone1, $myemail1, $myemail2, $mycphone, $uid, $ccid, $cname, $cdivision, $ccphone ) = $xoopsDB->fetchRow( $result ) ) {
					$myaddressdata = array();
					if( $fullname != "" ) {
						$myaddressdata['fullname'] = "<A href='".$mod_url."/viewaddress.php?mode=".$mode."&amp;cid=".$acid."&amp;op=edit&amp;aid=".$aid."'>".$myts->makeTboxData4Show($fullname)."<A>";
					} else {
						$myaddressdata['fullname'] = "Error: no fullname";
					}
					if( $cname != "" ) {
						$myaddressdata['cname'] = "<A href='".$mod_url."/viewcompany.php?mode=".$mode."&amp;cid=".$ccid."&amp;op=list&amp;c_id=".$c_id."'>".$myts->makeTboxData4Show($cname)." ".$cdivision."</A>";
					} else {
						$myaddressdata['cname'] = "";
					}
					if( $mycphone == "" ) $mycphone = $ccphone;
					$myaddressdata['cphone'] = $myts->makeTboxData4Show($mycphone);
					$myaddressdata['c_id'] = $myts->makeTboxData4Show($c_id);
					$myaddressdata['acid'] = $myts->makeTboxData4Show($acid);
					$myaddressdata['ccid'] = $myts->makeTboxData4Show($ccid);
					$myaddressdata['myphone'] = $myts->makeTboxData4Show($myphone);
					$myaddressdata['mycellphone1'] = $myts->makeTboxData4Show($mycellphone1);
					if ( $myemail1 != "" ) {
						$myaddressdata['myemail1'] = "<A HREF='mailto:". $myts->makeTboxData4Show($myemail1) ."'><IMG SRC='".XOOPS_URL."/images/icons/email.gif' BORDER='0' ALT='".sprintf( _SENDEMAILTO, $myts->makeTboxData4Show($myemail1) )."' /></A>";
					} else {
						$myaddressdata['myemail1'] = "";
					}
					if ( $myemail2 != "" ) {
						$myaddressdata['myemail2'] = "<A HREF='mailto:". $myts->makeTboxData4Show($myemail2) ."'><IMG SRC='".XOOPS_URL."/images/icons/email.gif' BORDER='0' ALT='".sprintf( _SENDEMAILTO, $myts->makeTboxData4Show($myemail2) )."' /></A>";
					} else {
						$myaddressdata['myemail2'] = "";
					}
					if( $isadmin || $my_uid == $uid ) {
						$myaddressdata['adminlink'] = "<A HREF='". $mod_url ."/viewaddress.php?cid=$cid&op=edit&aid=". $aid ."'>". _MD_MYADDRESS_EDIT. "</A> | <A HREF='". $mod_url ."/viewaddress.php?cid=$cid&op=del&aid=". $aid ."'>". _MD_MYADDRESS_DELETE ."</A>";
					} else {
						$myaddressdata['adminlink'] = "";
					}
					$addresses['myaddress'][] = $myaddressdata;
				}
				break;

			// company-based mode
			case 2:
				// get a company profile
				$sql = $select . $where . $order;

				$result = $xoopsDB->query( $sql, $myaddress_numperpage, $from );
				// assign header
				$addresses['lang_cname'] = _MD_MYADDRESS_COMPANY;
				$addresses['lang_cdivision'] = _MD_MYADDRESS_DIVISION;
				$addresses['lang_cphone'] = _MD_MYADDRESS_PHONE;
				$addresses['lang_cfax'] = _MD_MYADDRESS_FAX;
				$addresses['lang_cweb'] = _MD_MYADDRESS_WEB;
				$addresses['lang_send'] = _SEND;

				// assign a company profile data to the template
				while( list( $c_id, $ccid, $cdivision, $cname, $cphone, $cfax, $cweb ) = $xoopsDB->fetchRow( $result ) ) {
//					if( $caller == "viewcat.php" ) {
//						$companyprofile['cname'] = "<A href='".$mod_url."/viewcompany.php?mode=".$mode."&amp;cid=".$ccid."&amp;op=list&amp;c_id=".$c_id."'>".$myts->makeTboxData4Show($cname)."</A>";
//						$companyprofile['cdivision'] = "<A href='".$mod_url."/viewcompany.php?mode=".$mode."&amp;cid=".$ccid."&amp;op=list&amp;c_id=".$c_id."'>".$myts->makeTboxData4Show($cdivision)."</A>";
//					} else {
					$companyprofile['cname'] = $myts->makeTboxData4Show($cname);
					$companyprofile['cdivision'] = $myts->makeTboxData4Show($cdivision);
//					}
					$companyprofile['c_id'] = $myts->makeTboxData4Show($c_id);
					$companyprofile['company'] = $myts->makeTboxData4Show($cname)." ".$myts->makeTboxData4Show($cdivision);
					$companyprofile['cphone'] = $myts->makeTboxData4Show($cphone);
					$companyprofile['cfax'] = $myts->makeTboxData4Show($cfax);
					$companyprofile['ccid'] = $myts->makeTboxData4Show($ccid);
					if ( $cweb != "" && trim($cweb) != "http://" ) {
						$companyprofile['alt_msg'] = sprintf( _VISITWEBSITE, $myts->makeTboxData4Show($cweb) );
						$companyprofile['cweb'] = $myts->makeTboxData4Show($cweb);
//						$companyprofile['cweb'] = "<A HREF='".$myts->makeTboxData4Show($cweb)."' TARGET='_blank'><IMG SRC='".XOOPS_URL."/images/icons/www.gif' BORDER='0' ALT='".sprintf( _VISITWEBSITE, $myts->makeTboxData4Show($cweb) )."' /></A>";
					} else {
						$companyprofile['cweb'] = "";
					}
//					if( $uid == $my_uid || $isadmin ) {
					$companyprofile['lang_edit'] = _MD_MYADDRESS_EDIT;
					$companyprofile['lang_delete'] = _MD_MYADDRESS_DELETE;
//					$companyprofile['adminlink'] = "<A HREF='". $mod_url ."/viewcompany.php?cid=$cid&op=edit&c_id=". $c_id ."'>". _MD_MYADDRESS_EDIT. "</A> | <A HREF='". $mod_url ."/viewcompany.php?cid=$cid&action=del&c_id=". $c_id ."'>". _MD_MYADDRESS_DELETE ."</A>";
//					}
					$addresses['mycompany'][] = $companyprofile;
				}
				break;

			default:
				echo "mode is broken!";
				break;
		}
	}

	return $addresses;
}
?>
